public class Indivisual {

  int [][][] pattern;
  int [][][] vertexss;
  double fitness; 
  double fitness2; 
  int sumOfConvexs;
  int numberOfGenes;
  int col;
  int row;

  public Indivisual(int numberOfGenes, int col, int row) {
 
    this.numberOfGenes = numberOfGenes;
    this.col = col;
    this.row = row; 
    fitness = 0;
    fitness2 = 0;
    sumOfConvexs = 0;

    pattern = new int[numberOfGenes][col][row];
   
    //Generate Pattern 
    for (int i=0; i<numberOfGenes/2; i++) {
      for (int j=0; j<col; j++) {
        for (int k=0; k<row; k++) {
          if (j == 1 && k == 1) pattern[i][j][k] = 0;
          else pattern[i][j][k] = rnd.nextInt(3);
        }
      }
    }
    
    //Generate Complementary Pattern 
    for (int i=0; i<numberOfGenes/2; i++) {
      for (int j=0; j<col; j++) {
        for (int k=0; k<row; k++) {
          if (pattern[i][j][k] != 0) pattern[i+numberOfGenes/2][j][k] = 2 / pattern[i][j][k];
          else pattern[i+numberOfGenes/2][j][k] = 0;
        }
      }
    }
  }

  public Indivisual(Indivisual p) {
    this.numberOfGenes = p.numberOfGenes;
    this.col = p.col;
    this.row = p.row;
    this.sumOfConvexs = p.sumOfConvexs;
    this.fitness = p.fitness;
    this.fitness2 = p.fitness2;
    this.pattern = new int[numberOfGenes][col][row];

    for (int i=0; i<numberOfGenes; i++) {
      for (int j=0; j<col; j++) {
        for (int k=0; k<row; k++) {
          this.pattern[i][j][k] = p.pattern[i][j][k];
        }
      }
    }
  }

  public void evaluateFitness() {
    int[][] temp = new int[col][row];
    ArrayList<PVector> vertexs = new ArrayList<PVector>();
    
    int numberOfConvexs = 0;
    boolean sign = true;
    float tmpLength = 0;
    float maxLength = 0;
    int numberOfConfrontedConvex = 0;
    
    fitness = 0;
    fitness2 = 0;
    sumOfConvexs = 0;

    //Generate Complementary Pattern 
    for (int i=0; i<numberOfGenes/2; i++) {
      for (int j=0; j<col; j++) {
        for (int k=0; k<row; k++) {
          if (pattern[i][j][k] != 0) pattern[i+numberOfGenes/2][j][k] = 2 / pattern[i][j][k];
          else pattern[i+numberOfGenes/2][j][k] = 0;
        }
      }
    }

    for (int i=0; i<numberOfGenes/2; i++) {   
      for (int j = numberOfGenes/2; j<numberOfGenes; j++) {

        numberOfConvexs = 0;
        vertexs.clear();   
        numberOfConfrontedConvex = 0;
        
        if (i != j-numberOfGenes/2) {
          for (int m=0; m<col; m++) {
            for (int n = 0; n<row; n++) {
              temp[m][n] = pattern[i][m][n];

              if ((pattern[i][m][n] == 0 && pattern[j][m][n] == 1) || (pattern[i][m][n] == 1 && pattern[j][m][n] == 0)) {
                temp[m][n] = 1;
                vertexs.add(new PVector(m, n, 0));
                numberOfConvexs = numberOfConvexs + 1;
              }
              else if (pattern[i][m][n] == 1 && pattern[j][m][n] == 1) {
                temp[m][n] = 1;
                vertexs.add(new PVector(m, n, 0));
                numberOfConvexs = numberOfConvexs + 1;
                numberOfConfrontedConvex = numberOfConfrontedConvex + 1;
              }
              else {
                temp[m][n] = 2;
              }
            }
          }

          if (numberOfConvexs == 0) {
            fitness = fitness - 4; 
          }
          else if (numberOfConvexs == 1) {
            fitness = fitness - 3; 
          }
          else if (numberOfConvexs >= 2) {
            
            if (numberOfConvexs == 2 && numberOfConfrontedConvex == 0) fitness = fitness - 1.5;
            
            tmpLength = 0;
            maxLength = 0;
            
            for (int m = 0; m<vertexs.size(); m++) {
              for (int n = m+1; n<vertexs.size(); n++) {
                PVector tmp1 = vertexs.get(m);
                PVector tmp2 = vertexs.get(n);
                tmpLength = tmp1.dist(tmp2);
                if (tmpLength > maxLength) maxLength = tmpLength;
              }
            }

            if (maxLength < 1.5) fitness = fitness - 2;
            else if (maxLength < 2.1) fitness = fitness - 1;
          }
          
          if (numberOfConvexs > 2) {
            
            double areaOfPolygon = 0;
            PVector p1 = new PVector();
            PVector p2 = new PVector();

            for (int m=0; m<vertexs.size(); m++) {
              p1 = vertexs.get(m);
              if (m+1 < vertexs.size()) p2 = vertexs.get(m+1);
              else p2 = vertexs.get(0);  
              areaOfPolygon = areaOfPolygon + (p1.x*p2.y - p2.x*p1.y);
            }
            areaOfPolygon = Math.abs(areaOfPolygon/2);
            if (numberOfConfrontedConvex == 0 && areaOfPolygon < 1.6) fitness2 = fitness2 - 1; 
          }
        }
      }


      for (int j=0; j<col; j++) {
        for (int k=0; k<row; k++) {
          if (pattern[i][j][k] != 0) sumOfConvexs++;
        }
      }
    }
  }

  void set(Indivisual next) {
    this.sumOfConvexs = next.sumOfConvexs;
    this.numberOfGenes = next.numberOfGenes;
    this.fitness = next.fitness;
    this.fitness2 = next.fitness2;
    this.col = next.col;
    this.row = next.row;

    for (int i=0; i<numberOfGenes; i++) {
      for (int j=0; j<col; j++) {
        for (int k=0; k<row; k++) {
          this.pattern[i][j][k] = next.pattern[i][j][k];
        }
      }
    }
  }
  
}

